/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the NotificationAsset type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationAsset{}

// NotificationAsset struct for NotificationAsset
type NotificationAsset struct {
	Type string `json:"type"`
	Translations []NotificationAssetTranslation `json:"translations"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewNotificationAsset instantiates a new NotificationAsset object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationAsset(type_ string, translations []NotificationAssetTranslation, createdAt time.Time, updatedAt time.Time) *NotificationAsset {
	this := NotificationAsset{}
	this.Type = type_
	this.Translations = translations
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewNotificationAssetWithDefaults instantiates a new NotificationAsset object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationAssetWithDefaults() *NotificationAsset {
	this := NotificationAsset{}
	return &this
}

// GetType returns the Type field value
func (o *NotificationAsset) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *NotificationAsset) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *NotificationAsset) SetType(v string) {
	o.Type = v
}

// GetTranslations returns the Translations field value
func (o *NotificationAsset) GetTranslations() []NotificationAssetTranslation {
	if o == nil {
		var ret []NotificationAssetTranslation
		return ret
	}

	return o.Translations
}

// GetTranslationsOk returns a tuple with the Translations field value
// and a boolean to check if the value has been set.
func (o *NotificationAsset) GetTranslationsOk() ([]NotificationAssetTranslation, bool) {
	if o == nil {
		return nil, false
	}
	return o.Translations, true
}

// SetTranslations sets field value
func (o *NotificationAsset) SetTranslations(v []NotificationAssetTranslation) {
	o.Translations = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *NotificationAsset) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *NotificationAsset) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *NotificationAsset) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *NotificationAsset) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *NotificationAsset) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *NotificationAsset) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o NotificationAsset) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationAsset) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	toSerialize["translations"] = o.Translations
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableNotificationAsset struct {
	value *NotificationAsset
	isSet bool
}

func (v NullableNotificationAsset) Get() *NotificationAsset {
	return v.value
}

func (v *NullableNotificationAsset) Set(val *NotificationAsset) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationAsset) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationAsset) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationAsset(val *NotificationAsset) *NullableNotificationAsset {
	return &NullableNotificationAsset{value: val, isSet: true}
}

func (v NullableNotificationAsset) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationAsset) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


